<!DOCTYPE html>
<html>

<head lang="es">
	<meta charset="utf-8">
	<title>Trabajo en grupo TG1</title>
	<link rel="stylesheet" href="style.css">
</head>

<body>
	<header>
		<h1>Desarrollo con Tecnologías Emergentes. Curso 2019-20<br>
			Trabajo TG1 del grupo M3<br>
			Título: TG1.Encontrar recursos sobre dos tecnologías emergentes</h1>
	</header>
	<nav>
		<ul>
			<li><a href="#1">1. Información general</a></li>
			<li><a href="#2">2. Descripción del tipo de tecnología</a></li>
			<li><a href="#3">3. Fuentes de información (documentos)</a></li>
			<li><a href="#4">4. Fuentes de información (cursos no gratuitos)</a></li>
			<li><a href="#5">5. Fuentes de información (cursos gratuitos)</a></li>
			<li><a href="#6">6. Ayudas económicas para estudiar las tecnologí­as</a></li>
			<li><a href="#7">7. Recursos para implementar las tecnologí­as</a></li>
			<li><a href="#8">8. Conclusiones</a></li>
		</ul>
	</nav>

	<main>
		<section id=1">
			<h2>1. Información general</h2>
			<h3>1.1 Autores</h3>
			<p>
			Grupo: M3
			</p>
			<p>Integrantes del grupo:
			Adina Murg (Product Owner),
			Arman Ananian Lalayan (Developer),
			Adrián Valledor Pérez (Developer),
			Diego Lobo Bellón (Developer),
			Diego Gerardo Estalrich Cuellar (Developer)
			</p>
			<h3>1.2 Proyecto Scrum y repositorio en GitLab</h3>
			<p>URL Proyecto TG1 del grupo M3:</p>
			<a href="https://gitlab.com/dte2020/m3/tg1/">Proyecto M3</a> 
			<p>URL Sprint(Milestone):</p>
			<a href="https://gitlab.com/dte2020/m3/tg1/-/milestones">Proyecto M3</a> 
			
			<h3>1.3 Burndown chart</h3>
			<p>Diagrama Burndown final del Sprint TG1:

			</p>
			<img src="BurndownTG1.jpg">
			<h3>1.4 Presentación del trabajo</h3>
			<p>Enlace al archivo de la presentación: 

			</p>
			<a href="PresentaciónTG1.pptx">Presentación con diapositivas del trabajo TG1</a></p>
		</section>
		<section id="2">
			<h2>2. Descripción del tipo de tecnología</h2>
			<p>La tecnología general que trataremos es la de web scraping, técnica 
				que se encarga de extraer grandes cantidades de datos de diversas 
				páginas para posteriormente emplearlos para diversos fines, como por ejemplo,
				 para monitorizar precios. Como tecnologías específicas,hemos decidido seleccionar
				  Cheerio Y Puppeteer, tecnologías que nos ayudan a automatizar el proceso para no tener 
				  que hacerlo de forma manual. La selección de estas dos tecnologías se debe a que son 
				  actualmente unas de las más empleadas.</p>
            <p>Cheerio: es una librería Node.js que se encarga de ayudar a los desarrolladores a interpretar 
				y analizar páginas web usando una sintaxis jQuery. Además de ser de código abierto cuenta con 
				grandes patrocinadores como Airbnb. Nos permite su uso comercial. </p>
            <p>Puppeteer: es otra librería Node que nos proporciona una API de alto nivel para controlar 
				Chrome a través del protocolo DevTools (conjunto de herramientas de creación y depuración web 
				integrado en Google Chrome). También es un software de código abierto que permite incluso su 
				uso comercial.</p>

			</p>
		</section>
		<section id="3">
			<h2>3. Fuentes de información (documentos)</h2>
			<h3>3.1 Fuentes de información sobre el tipo de tecnología en general </h3>
			<h4>3.1.1 Fuente de información 1 sobre el tipo de tecnología en general</h4>
			<p>Una primera fuente de información puede ser la que dejaremos a continuación,
				ya que en ella se describe de forma general esta tecnología, su funcionamiento, para qué sirve y
				además, se muestran
				varios ejemplos de herramientas (como Import.io, Scrapy.org...) y posibles aplicaciones útiles que se podrían 
				desarrollar haciendo uso de esta tecnología.</p>
			<a href="https://sitelabs.es/web-scraping-introduccion-y-herramientas/">Enlace a la fuente</a>
			<h4>3.1.2 Fuente de información 2 sobre el tipo de tecnología en general</h4>
			<p>Nuestra segunda fuente de información será la propia sugerida por el profesor en el documento Excel original,
				donde se comparan 5 tecnologías diferentes (Osmosis, Cheerio...), escogiendo dos de ellas sobre las que trabajaremos a continuación.</p>
			<a href="https://dzone.com/articles/5-best-web-scraping-tools-to-increase-your-data-an">Enlace a la fuente</a>
			<h4>3.1.3 Fuente de información 3 sobre el tipo de tecnología en general</h4>
			<p>Esta fuente nos muestra posibles usos que se podrían llevar a cabo haciendo uso de web scraping, de forma
				que nos muestra su utilidad, además de proponernos 10 nuevas herramientas
				sobre las que trabajar (Dexi.io, Webhose.io...), aunque la mayoría de ellas son de pago.</p>
			<a href="https://blog.tednologia.com/10-mejores-herramientas-de-web-scraping-para-extraer-datos-en-linea/">Enlace a la fuente</a>
			<h4>3.1.4 Fuente de información 4 sobre el tipo de tecnología en general</h4>
			<p>La siguiente fuente presenta varias posibles herramientas de web scraping, todas ellas gratuitas, como Table Capture o ScraperWiki (pero si queremos alguna versión
				más completa pasarían a la modalidad de pago) además de acompañar las herramientas con vídeos-tutoriales.</p>
			<p>Entre las herramientas encontramos ScraperWiki, librerías de Python o herramientas que se pueden instalar directamente.</p>
			<a href="https://bbvaopen4u.com/es/actualidad/herramientas-de-extraccion-de-datos-para-principiantes-y-profesionales">Enlace a la fuente</a>

			<h3>3.2 Fuentes sobre la tecnología específica Puppeteer </h3>
			<h4>3.2.1 Fuente de información 1 sobre la tecnología específica Puppeteer</h4>
			<p>En esta primera fuente, se nos explica la herramienta Puppeteer, acompañado de una breve ayuda a la instalación y requisitos a cumplir
				 y se nos muestra un ejemplo guiado de como utilizarlo sobre una web.</p>
			<a href="https://blog.bitsrc.io/web-scraping-with-puppeteer-e73e5fee7474?gi=3d01cb4efdc7">Enlace a la fuente</a>
			<h4>3.2.2 Fuente de información 2 sobre la tecnología específica Puppeteer</h4>
			<p>En esta fuente se nos vuelven a mostrar las funcionalidades y usabilidades de Puppeteer y la instalación de Node.js, utilizando un ejemplo sobre la página
				de booking.com </p>
			<a href="https://www.scrapehero.com/how-to-build-a-web-scraper-using-puppeteer-and-node-js/">Enlace a la fuente</a>
			<h4>3.2.3 Fuente de información 3 sobre la tecnología específica Puppeteer</h4>
			<p>En esta fuente volvemos a ver otro tutorial sobre Puppeteer desde cero. Este tutorial se centra, sobre todo, 
				en trabajar sobre las capturas de pantalla de sitios web. Nos proporciona código e imágenes con resultados muy detallados y explicados.</p>
			<a href="https://medium.com/swlh/an-introduction-to-web-scraping-with-puppeteer-3d35a51fdca0">Enlace a la fuente</a>
			<h4>3.2.4 Fuente de información 4 sobre la tecnología específica Puppeteer</h4>
			<p>En esta última fuente podemos encontrar un repositorio de GitHub para utilizar Puppeteer.</p>
			<a href="https://github.com/website-scraper/website-scraper-puppeteer">Enlace a la fuente</a>

			<h3>3.3 Fuentes sobre la tecnología específica Cheerio </h3>
			<h4>3.3.1 Fuente de información 1 sobre la tecnología específica Cheerio</h4>
			<p>Una buena primera fuente de información es la página con la documentación oficial de Cheerio, que incluye el acceso a la carpeta de GitHub con
				códigos y más documentación adicional. Además, se describen algunas de sus características, patrocinadores y todas sus funciones y comandos.</p>
			<a href="https://cheerio.js.org/#table-of-contents">Enlace a la fuente</a>
			<h4>3.3.2 Fuente de información 2 sobre la tecnología específica Cheerio</h4>
			<p>Otra fuente de información es la siguiente página, donde se nos muestran los primeros pasos para instalar Cheerio y 
				comenzar su utilización con un tutorial que nos ejemplifica cómo realizarlo.</p>
			<a href="https://buttercms.com/blog/web-scraping-with-nodejs-and-cheerio">Enlace a la fuente</a>
			<h4>3.3.3 Fuente de información 3 sobre la tecnología específica Cheerio</h4>
			<p>En esta última fuente se puede ver un video ejemplificativo en el que se intenta realizar web scraping a la página de idealista.com a 
				través de Node.js junto con Cheerio. Decimos que lo intentan, porque el portal de idealista está protegido ante estas técnicas.</p>
			<a href="https://www.todojs.com/introduccion-al-scraping-con-cheerio-por-ruben-valseca/">Enlace a la fuente</a>
		</section>

		<section id="4">
			<h2>4. Fuentes de información (cursos no gratuitos)</h2>
			<p>En los sub-apartados de este apartado se indican cursos no gratuitos para aprender sobre el tipo
				de web scrapping en general, y sobre cada una de las tecnologí­as elegidas, en nuestro caso se tratará de Puppeteer y Cheerio.</p>
			<h3>4.1 Cursos no gratuitos sobre el tipo de tecnologí­a en general </h3>
			<h4>4.1.1 Curso no gratuito 1 sobre el tipo de tecnologí­a en general</h4>
			<p>Descripción del curso: El primer curso elegido para la tecnología en general no tiene un alto nivel de requerimientos previos, por lo que 
			puede ser cursado por la mayoría de estudiantes, además el precio del curso es de 10,99€ (en oferta) por lo que el coste no supone una barrera de entrada para la formación.
			En este curso se incluye una introducción al web-scraping y a aspectos esenciales de la tecnología en un marco teórico. Además se muestra la 
			implementación de un recolector de precios de ecommerce como ejemplo.</p>
			<a href="https://www.udemy.com/course/big-data-data-science-python-web-scraping-2019-achirou-alvaro-chirou/">Enlace al curso</a>
			<h4>4.1.2 Curso no gratuito 2 sobre el tipo de tecnologí­a en general</h4>
			<p>Descripción del curso: El segundo curso ha sido seleccionado en base a los mismos criterios. Tiene un precio de 10,99€ y no exige demasiados requerimientos de entrada.
			La principal diferencia es que este curso es de carácter práctico. Cubre los aspectos fundamentales de web scraping en python.</p>
			<a href="https://www.udemy.com/course/introduction-to-data-exractionweb-scraping-in-python/">Enlace al curso</a>
			<h4>4.1.3 Curso no gratuito 3 sobre el tipo de tecnologí­a en general</h4>
			<p>Descripción del curso: Al igual que los dos primeros cursos este curso es accesible con respecto a su precio (10,99€) y requerimientos de entrada.
			Este curso está enfocado a estrategias de web scaping. También hace una introducción a distintos frameworks para la implementación de la tecnoloía.</p>
			<a href="https://www.udemy.com/course/web-scrapping-course/">Enlace al curso</a>
			<h4>4.1.4 Curso no gratuito 4 sobre el tipo de tecnologí­a en general</h4>
			<p>Descripción del curso: Este curso es accesible con respecto a su precio (10,99€) y requerimientos de entrada. Este incluye una introducción en ambos marcos teórico y práctico
			al web scraping con Node.js.</p>
			<a href="https://www.udemy.com/course/web-scraping-in-nodejs/">Enlace al curso</a>
			<h4>4.1.5 Curso no gratuito 5 sobre el tipo de tecnologí­a en general</h4>
			<p>Descripción del curso: Este curso es accesible con respecto a su precio (10,99€) y requerimientos de entrada. Este incluye una introdución al web scraping
			en el ámbito práctico utilizando el framework Scrapy.</p>
			<a href="https://www.udemy.com/course/scrapy-tutorial-web-scraping-with-python/">Enlace al curso</a>

			<h3>4.2 Cursos no gratuitos sobre la tecnologí­a especí­fica A. Puppeteer </h3>
			<h4>4.2.1 Curso no gratuito 1 sobre la tecnologí­a especí­fica A.</h4>
			<p>Descripción del curso: Puppeteer es una librería de node.js por lo que la mayoría de recursos formativos son gratuitos. Este curso introduce 
			el web scraping con Node.js enfocándose principalmente en puppeteer y mostrando otras herramientas similares. El precio actual en oferta es de 10,99€, normal a 104,99€. </p>
			<a href="https://www.udemy.com/course/nodejs-web-scraping/">Enlace al curso</a>
			<h4>4.2.2 Curso no gratuito 2 sobre la tecnologí­a especí­fica A.</h4>
			<p>Descripción del curso: En este curso se trata la automatización de pruebas de software, aun así se imparten temas relacionados con el web 
			scraping y se dedica el último apartado a la implementación de un web scraper utilizando puppeteer. El curso está disponible por 49,99€ y se requieren
			conocimientos de javascript, automatización de tests y Node.js</p>
			<a href="https://www.udemy.com/course/automated-headless-browser-testing-with-puppeteer/">Enlace al curso</a>

			<h3>4.3 Cursos no gratuitos sobre la tecnologí­a especí­fica B. Cheerio </h3>
			<h4>4.3.1 Curso no gratuito 1 sobre la tecnologí­a especí­fica B</h4>
			<p>Descripción del curso: Este curso se trata de web scraping con Node.js, en una sección del mismo se explica como utilizar cheerio. cuesta 10,99€ en oferta, 74,99€ precio habitual.
			Requiere un conocimiento básico de Node.js</p>
			<a href="https://www.udemy.com/course/web-scraping-nodejs/">Enlace al curso</a>
			<h4>4.3.2 Curso no gratuito 2 sobre la tecnologí­a especí­fica B</h4>
			<p>Descripción del curso: Este curso trata de web scraping con Javascript, trata diversos métodos de extracción, enfocándose en Cheerio. Cuesta 124,99€ sin oferta y 
			requiere conocimientos de Javascript.</p>
			<a href="https://www.udemy.com/course/learning-web-scraping-with-javascript/">Enlace al curso</a>
			<h4>4.3.N Curso no gratuito N sobre la tecnologí­a especí­fica B</h4>
			<p>Descripción del curso: En este curso titulado beginners guide to web development hay un apratado en el que se muestra como web scrapear Amazon utilizando
			Cheerio. Cuesta 199,99€ sin oferta y no requiere de conocimientos previos.</p>
			<a href="https://www.udemy.com/course/beginners-guide-to-web-development/">Enlace al curso</a>
		</section>

		<section id="5">
			<h2>5. Fuentes de información (cursos gratuitos)</h2>

			<h3>5.1 Cursos gratuitos sobre el tipo de tecnologí­a en general </h3>
			<h4>5.1.1 Curso gratuito 1 sobre el tipo de tecnologí­a en general</h4>
			<p>En el primero caso, tenemos un pqeueño tutorial sobre Web Scraping gratuito, realizado por un experto.
			   No necesitaremos conocimientos previos para realizarlo aunque si tenemos una base de de programación básica nos ayudará a entenderlo mejor. 
			</p>
			<a href="https://www.udemy.com/course/webscraping-without-scrapy/">Primer curso</a>
			<h4>5.1.2 Curso gratuito 2 sobre el tipo de tecnologí­a en general</h4>
			<p>En este caso, tenemos un curso sobre Web Scraping centrado en las librerías Python, más extenso que el anterior.</p>
			<a href="https://www.udemy.com/course/web-scraping-python-tutorial/">Segundo curso</a>
			<h4>5.1.3 Curso gratuito 3 sobre el tipo de tecnologí­a en general</h4>
			<p>Otro curso algo más profundo, en el que si que necesitaremos algunos conocimientos previos para realizarlo.</p>
			<a href="https://www.codecademy.com/learn/learn-web-scraping">Tercer curso</a>
			<h4>5.1.4 Curso gratuito 4 sobre el tipo de tecnologí­a en general</h4>
			<p>Otro curso en el que aprender a realizar Web Scraping usando las librerías Python</p>
			<a href="https://www.datacamp.com/courses/web-scraping-with-python?utm_source=adwords_ppc&utm_campaignid=898687156&utm_adgroupid=48303643819&utm_device=c&utm_keyword=&utm_matchtype=b&utm_network=g&utm_adpostion=&utm_creative=229335520231&utm_targetid=aud-299261629574:dsa-377762271983&utm_loc_interest_ms=&utm_loc_physical_ms=1005487&gclid=CjwKCAjw3-bzBRBhEiwAgnnLCk0c_YCNTr-Lt2ImAuptWS50ytgueljC2Jx_D-3yyGTrepnkejcmyBoCy8gQAvD_BwE">Cuarto curso</a>

			
			<h3>5.2 Cursos gratuitos sobre la tecnologí­a especí­fica A </h3>
			<h4>5.2.1 Curso gratuito 1 sobre la tecnologí­a especí­fica A</h4>
			<p>Debido a que no ha sido posible encontrar cursos gratuitos sobre Puppeteer, tenemos su página principal donde nos enseñana manejar
			   esta herramienta desde cero, con el único inconveniente de que está en inglés.
			</p>
			<a href="https://pptr.dev/">Primer curso</a>
			<h4>5.2.2 Curso gratuito 2 sobre la tecnologí­a especí­fica A</h4>
			<p>En este caso tenemos una gran guía en la que nos enseñan a manejar Puppeteer entre otras herramientas</p>
			<a href="https://codeburst.io/a-guide-to-automating-scraping-the-web-with-javascript-chrome-puppeteer-node-js-b18efb9e9921">Segundo curso</a>

			<h3>5.3 Cursos gratuitos sobre la tecnologí­a especí­fica B </h3>
			<h4>5.3.1 Curso gratuito 1 sobre la tecnologí­a especí­fica B</h4>
			<p>Debido a que tampoco se encontraron cursos sobre Cheerio, podemos utilizar su página principal, donde viene mucha documentación e información 
				sobre el uso y manejo de esta herramienta.
			</p>
			<a href="https://cheerio.js.org/">Primer curso</a>
			<h4>5.3.2 Curso gratuito 2 sobre la tecnologí­a especí­fica B</h4>
			<p>Aunque no sea un curso como tal, tenemos un vídeo donde nos muestra como realizar Web Scraping mediante el uso de Cheerio y en español.</p>
			<a href="https://www.youtube.com/watch?v=dJpSTPUVKQU">Segundo curso</a>



		</section>

		<section id="6">
			<h2>6. Ayudas económicas para estudiar las tecnologí­as</h2>

				<p>NOTA:Actualmente no hay ningún programa de becas especializado en las tecnologías relacionadas con Web Scraping, 
					y tampoco enfocadas a las ciencias de la computación desde el punto de vista de cubrir económicamente los cursos propuestos. Todos los cursos no gratuitos 
					que se han propuesto y hemos considerado los más eficientes y adecuados pertenecen a Udemy, una plataforma digital en la que diversos profesores de forma 
					autónoma dirigen, gestionan y crean sus cursos. Dicha plataforma no cuenta con la capacidad de ofrecer descuentos, por ejemplo, a estudiantes y/o profesores,
					 por lo que a continuación citaremos las mejores ayudas económicas que poder emplear. </p>
				<h3>6.1 Ayuda 1: Uso de cupones descuento</h3>
				<p>Udemy nos ofrece descuentos constantes, como en fechas especiales (Navidad, Halloween...) además de ofertas flash, de las cuales podemos enterarnos vía email si
					 estamos suscritos. Estas ofertas llegan hasta un 90% de descuento, reduciendo el precio de cursos de hasta 199€ a 9,99€, como ya mencionamos anteriormente. 
					 Otra opción es hacer uso de cupones de páginas especializadas, que recopilan y distribuyen códigos de un descuento del 100%. Algunas de estas páginas son, por ejemplo, 
					 discudemy.com o couponscorpion.com. Como ejemplo escogeremos un curso donde podemos aprender como hacer web scraping usando Node.js y Cheerio de cualquier web, pero no 
					 sólo hacer el scraping en sí, si no de cómo mostrar los datos recabados haciendo uso de Angular. Tan sólo debemos hacer click sobre View Deal para que nos redirija a la 
					 página oficial de Udemy del curso ya con el descuento incluido.</p>
				<a href="http://udemycoupon.discountsglobal.com/coupon/100-off-learn-web-scraping-with-node-js-course-coupon-free/">87% descuento en curso de Web Scraping con Cheerio</a>
				<h3>6.2 Ayuda 2: Contactos</h3>
				<p>Una de las mejores formas, más útiles, seguras y más empleadas es el de los contactos directos con el profesor del propio curso. Todos los profesores que imparten cursos
					 cuentan con perfil en Udemy, entre los cuales muchos citan sus redes sociales (Facebook, Twitter, Linkedin...) hasta YouTube y sus propias páginas web. A través de ellas, 
					 nos podemos poner en contacto con el propio profesor, el cual nos podrá permitir un descuento del 100% en el curso a cambio de una valoración positiva (5 estrellas) en sus curso.
					  Como se comenta, es una técnica muy empleada, que no sólo favorece al alumno si no al profesor, el cual mejora en clasificaciones por su puntuación y su número de alumnos apuntados. 
					  Por otro lado, también se cuenta con numerosos grupos de Facebook, denominados Udemy Studio que se encargan de poner en contacto a profesores de cursos gratuitos y alumnos interesados.
</p>
				<a href="https://www.udemy.com/user/grohs-fabian/">Ejemplo perfil profesor Udemy y medios de contacto</a>

			</p>
		</section>

		<section id="7">
			<h2>7. Recursos software o hardware para implementar las tecnologí­as</h2>

			<h3>7.1 Recursos para implementar la tecnologí­a A</h3>
			<h4>7.1.1 Recursos gratuitos para implementar la tecnologí­a A</h4>
			<p>Se trata de la mejor opción para implementar Puppeteer ya que se integra con Headless Chrome para la mejor visualización de los recursos.</p>
			<a href="https://github.com/puppeteer/puppeteer">Headless Chrome</a>
			<h4>7.1.2 Recursos no gratuitos para implementar la tecnologí­a A</h4>
			<p>Esta tecnologia se ocupa de las dependencias, sand boxes y el manejo del navegador</p>
			<a href="https://www.browserless.io">Browserless</a>

			<h3>7.2 Recursos para implementar la tecnologí­a B</h3>
			<h4>7.2.1 Recursos gratuitos para implementar la tecnologí­a B</h4>
			<p>Después de investigar bastante hemos concluido que se puede usar la herramienta gratuita de Jest para correr el código de Cheerio, Jest es un Framework que hace tests de Javascript.</p>
			<a href="https://jestjs.io">Jest</a>
			<h4>7.2.2 Recursos no gratuitos para implementar la tecnologí­a B</h4>
			<p>En cuanto a herramientas de pago no encontramos ninguna para Cheerio porque todo se puede implementar con herramientas gratuitas accesibles a todo el mundo, lo cual es buena noticia, aqui presentamos un articulo paso por paso de como se podria implementar:</p>
			<a href="https://dev.to/hugoliconv/how-to-build-a-price-scraper-using-javascript-and-cheerio-js-4b9e">Dev.to</a>
		</section>

		<section id="8">
			<h2>8. Conclusiones</h2>
			<p>Respecto a las conclusiones, hemos tenido la oportunidad de emplear por primera vez la herramienta de GitLab
				con la cual hemos podido descubrir las utilidades que nos proporciona, sobretodo la capacidadde poder trabajar
				varias personas a la vez en el mismo proyecto, además de poder organizar mejor el grupo de trabajo tanto en el reparto
				de tareas como en el ajuste de tiempos. Por otra parte, esto a su vez nos ha generado un de problema,
				como la dificultad a la hora de subir correctamente la información y generar un merge correcto, aunque solucionamos
				el problema tras varios intentos.

				</p>
				<p>Acerca de la búsqueda de información, encontramos problemas a la hora de buscar cursos
					gratuitos y ayudas económicas, dado la reducida cantidad de información que encontramos, sobretodo
					por ser muy nueva y poco extendida, la tecnología de web scrapping y sobretodo Cheerio y Puppeteer,
					que dado que son nuevas herramientas emergentes todavía no tienen una gran comunidad detrás para apoyarlas.
				
				</p>
				<p> En general, creemos que hemos logrado cumplir con los objetivos de esta práctica de una manera lo más correcta y posible
					intentando encontrar las mejores alternativas frente a los apartados que nos han generado más dificultades.
				</p>
		</section>

	</main>

</body>

</html>
 
